[x,y,z] = peaks(100);
x = x(1,:);
y = y(:,1);

%Find starting point
[a,b] = max(z);
[a2,b2] = max(a);

%Initialize path
%x_0 = b(b2)-5;
%y_0 = b2;

x_0 = 75;
y_0 = 50;
z_0 = z(x_0,y_0);

%Initialize path history
x_hist = x_0;
y_hist = y_0;
z_hist = z_0;

x_curr = x_0;
y_curr = y_0;
z_curr = z_0;

x_end = [];
y_end = [];
z_end = [];

for i = 1:5
x_0 = round(80*rand())+10;
y_0 = round(80*rand())+1`0;

[ x_curr,y_curr,x_hist,y_hist,z_hist ] = SteepestDescent_Random( x_0,y_0,z_0,z,x_hist,y_hist,z_hist );

x_hist = x_0;
y_hist = y_0;
z_hist = z_0;

x_end = [x_end,x_curr];
y_end = [y_end,y_curr];
z_end = [z_end,z(x_curr,y_curr)];
end

figure
hold on
surfc(z,'EdgeColor','none')
scatter3(y_0,x_0,z_0+0.5,'Linewidth',5);
scatter3(y_end,x_end,z_end+0.1,'Linewidth',2);
scatter3(y_hist(end),x_hist(end),z_hist(end)+0.1,'Linewidth',5);
legend('Surface','Contour map','Start point','Path','End point');

